import { ElementContainerFactory } from "./element-container-factory";
import { EscListener } from "./esc-listener";
import { CtrlEnterListener } from "./ctrl-enter-listener";
export class ObjectOrientedBootstrapModal {
    constructor(config) {
        this.escListener = new EscListener(this);
        this.onConfirm = null;
        this.rawOnConfirmListener = () => {
            if (this.onConfirm) {
                this.onConfirm();
            }
        };
        this.container = new ElementContainerFactory(config).createContainer();
        if (config.onConfirm) {
            this.onConfirm = config.onConfirm;
        }
        this.container.addConfirmButtonListener(this.rawOnConfirmListener);
        this.ctrlEnterListener = new CtrlEnterListener(this.rawOnConfirmListener);
        this.container.addCloseButtonListener(() => this.close());
    }
    open() {
        this.container.insertSelf();
        this.escListener.engage();
        this.ctrlEnterListener.engage();
    }
    close() {
        this.container.removeSelf();
        this.escListener.disengage();
        this.ctrlEnterListener.disengage();
    }
    get content() {
        return this.container.getContentElement();
    }
}
